using System.ComponentModel;
using System.Diagnostics;

using CommunityToolkit.Mvvm.ComponentModel;

namespace NSeguin.Dev.Web;

public class UserConfiguration : ObservableObject
{
    private DarkModeState _darkMode = DarkModeState.System;
    public DateTimeOffset? LastUpdatedAt { get; private set; }

    public DarkModeState DarkMode
    {
        get => _darkMode;
        set => SetProperty(ref _darkMode, value);
    }

    protected override void OnPropertyChanged(PropertyChangedEventArgs e)
    {
        Debug.WriteLine($"Property changed: {e.PropertyName}");
        LastUpdatedAt = DateTimeOffset.UtcNow;
        base.OnPropertyChanged(e);
    }
}
