namespace NSeguin.Dev.Web.Components.Shared;

public record HeroIconKind(string FileName)
{
    private const string PathBase = "wwwroot/lib/heroicons";

    private readonly Lazy<Task<string>> _solid = new(
        () => File.ReadAllTextAsync(GetPath(FileName, false, false)));

    private readonly Lazy<Task<string>> _outline = new(
        () => File.ReadAllTextAsync(GetPath(FileName, false, true)));

    private readonly Lazy<Task<string>> _small = new(
        () => File.ReadAllTextAsync(GetPath(FileName, true, false)));

    public string FileName { get; } = FileName;
    internal Task<string> Solid => _solid.Value;
    internal Task<string> Outline => _outline.Value;
    internal Task<string> Small => _small.Value;

    private static string GetPath(string fileName, bool small, bool outline)
    {
        return Path.Combine(PathBase, small ? "20" : "24", outline ? "outline" : "solid", fileName);
    }
}
